#include <pthread.h>
#include <stdio.h>

#include <unistd.h>

pthread_cond_t c1;
pthread_mutex_t m1;

void* foo(void* data)
{
	int ret;
	/* EBUSY */
	ret = pthread_mutex_trylock(&m1);	printf("foo:%d\n", ret);
	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("foo:%d\n", ret);

	sleep(1);
	/* 0 */
	ret = pthread_mutex_unlock(&m1);		printf("foo:%d\n", ret);

	pthread_exit(NULL);
}



int main()
{
	int ret;

	/* OK, 0 */
	ret = pthread_mutex_init(&m1, NULL);	printf("main:%d\n", ret);

	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("main:%d\n", ret);

	pthread_t t1;
	/* OK, 0 */
	ret = pthread_create(&t1, NULL, foo, NULL);	printf("main:%d\n", ret);
	
	sleep(1);

	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("main:%d\n", ret);

	/* EPERM */
	ret = pthread_mutex_unlock(&m1);	printf("main:%d\n", ret);

	pthread_join(t1, NULL);
	printf("OK!\n");
	return 0;
}
