/** mm_test01.c
 *
 * This test checks memory model used in GMC.
 *  Ability of backtracking over method calls is tested.
 *  Checks whether undo operations handles method calls correctly.
 *
 *  Note: Based on really found error.
 *
 *  @Author: Alf
 */

#include <stdio.h>
#include <stdlib.h>

int global = 0;

int simple_function(int x) {
    return x + 2;
}

int main(void) {
    printf("%s\n", "mm_test01.c - Memory undo operations test");

    global = rand() % 2; // scheduling point)

    // Function call
    int tmp = simple_function(global);
    printf("simple_function(%d)=%d\n", global, tmp);

    return 0;
}
