/**
 * This test fails. For some reason, the statement
 *
 * enum DAY yesterday2 = ( enum DAY ) ( today - 2 );
 * is in GIMPLE
 * gimple_assign <plus_expr, yesterday2, today, 0x0fffffffe>,
 * where the (-2) constant has the TYPE_UNSIGNED flag set to true,
 * therefore GMC considers it to be an unsigned variable.
 * That results in a wrong evaluation of the variable.
 */

#include <stdio.h>

int
main(void)
{
	enum DAY            /* Defines an enumeration type    */
	{
	    saturday,       /* Names day and declares a       */
	    sunday = 0,     /* variable named workday with    */ 
	    monday,         /* that type                      */
	    tuesday,
	    wednesday,      /* wednesday is associated with 3 */
	    thursday,
	    friday
	} workday;

	enum DAY today = wednesday;
	enum DAY yesterday = ( enum DAY ) ( today + 1 );
	enum DAY yesterday2 = ( enum DAY ) ( today - 2 );
	enum DAY yesterday3 = ( enum DAY ) ( 2 - 1 );

	printf("%d,%d,%d\n", today, yesterday, yesterday2);

	enum BOOLEAN  // Declares an enumeration data type called BOOLEAN
	{
	    FALSE,     // false = 0, true = 1
	    TRUE 
	}; 

	enum BOOLEAN end_flag, match_flag = 0; // Two variables of type BOOLEAN

	if ( match_flag == FALSE )
	{
		printf("%s\n", "FALSE");
	}
	end_flag = TRUE;
	
	return 0;
}
