// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file Decls.h
 * Header including all headers for declarations.
 */
#ifndef GIT_DECLS_H
#define GIT_DECLS_H

#include "FunctionDecl.h"
#include "VarDecl.h"
#include "RecordDecl.h"
#include "ParamDecl.h"
#include "LabelDecl.h"
#include "ResultDecl.h"
#include "TypeDecl.h"
#include "FieldDecl.h"
#include "ConstDecl.h"

#endif /* GIT_DECLS_H */
