// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

/** @file Values.h
 * Header including all headers for simulated values.
 */
#ifndef INT_VALUES_H
#define INT_VALUES_H

#include "BoolValue.h"
#include "PtrValue.h"
#include "IntegerValue.h"
#include "EnumeralValue.h"
#include "RealValue.h"
#include "StringValue.h"
#include "FunctionValue.h"
#include "BuiltinFunctionValue.h"
#include "ThreadFunctionValue.h"
#include "RecordValue.h"
#include "ArrayValue.h"
#include "ArrayConstructorValue.h"
#include "RecordConstructorValue.h"

#endif /* INT_VALUES_H */
