#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

pthread_cond_t c1;
pthread_mutex_t m1;

void* foo(void* data)
{
	int ret;
	sleep(2);

	pthread_cond_signal(&c1);
}

int main()
{
	pthread_t t1;
	pthread_create(&t1, NULL, foo, NULL);
	int ret;
	
	ret = pthread_cond_init(&c1, NULL);	printf("%d\n", ret);

	ret = pthread_cond_destroy(&c1);	printf("%d\n", ret);

	ret = pthread_cond_init(&c1, NULL);	printf("%d\n", ret);

	ret = pthread_mutex_init(&m1, NULL);	printf("%d\n", ret);

	ret = pthread_cond_wait(&c1, &m1);	printf("%d\n", ret);

	ret = pthread_mutex_trylock(&m1); printf("main: trylock: %d\n", ret);

	printf("OK!\n");
	return 0;
}
