#include <pthread.h>
#include <stdio.h>

/*
0
22
0
22
22
22
22
0
0
0
0
35
16
16
0
1
0
0
OK!
*/

int main()
{
	pthread_mutex_t m1;
	int ret;
	
	/* OK, 0 */
	ret = pthread_mutex_init(&m1, NULL);	printf("%d\n", ret);
	/* Init again, EINVAL */
	ret = pthread_mutex_init(&m1, NULL);	printf("%d\n", ret);

	/* OK, 0 */
	ret = pthread_mutex_destroy(&m1);	printf("%d\n", ret);

	/* EINVAL */
	ret = pthread_mutex_lock(&m1);		printf("%d\n", ret);
	/* EINVAL */
	ret = pthread_mutex_unlock(&m1);	printf("%d\n", ret);
	/* EINVAL */
	ret = pthread_mutex_trylock(&m1);	printf("%d\n", ret);

	/* Again, EINVAL */
	ret = pthread_mutex_destroy(&m1);	printf("%d\n", ret);

	/* OK, 0 */
	ret = pthread_mutex_init(&m1, NULL);	printf("%d\n", ret);

	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("%d\n", ret);
	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("%d\n", ret);

	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("%d\n", ret);
	/* EDEADLK */
	ret = pthread_mutex_lock(&m1);		printf("%d\n", ret);

	/* EBUSY */
	ret = pthread_mutex_trylock(&m1);	printf("%d\n", ret);
	/* EBUSY */
	ret = pthread_mutex_trylock(&m1);	printf("%d\n", ret);

	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("%d\n", ret);
	/* EPERM */
	ret = pthread_mutex_unlock(&m1);	printf("%d\n", ret);

	/* 0 */
	ret = pthread_mutex_trylock(&m1);	printf("%d\n", ret);
	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("%d\n", ret);

	printf("OK!\n");
	return 0;
}
