#include <pthread.h>
#include <stdio.h>
#include <unistd.h>

pthread_mutex_t m1;

/* Should write:
all zeros
*/

void* foo(void* data)
{
	int ret;
	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("foo:%d\n", ret);
	sleep(1);
	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("foo:%d\n", ret);

	pthread_exit(NULL);
}

void* foo2(void* data)
{
	int ret;
	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("foo2:%d\n", ret);
	sleep(1);
	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("foo2:%d\n", ret);

	pthread_exit(NULL);
}


int main()
{
	int ret;

	/* OK, 0 */
	ret = pthread_mutex_init(&m1, NULL);	printf("main:%d\n", ret);
	/* 0 */
	ret = pthread_mutex_lock(&m1);		printf("main:%d\n", ret);

	pthread_t t1, t2;
	/* OK, 0 */
	ret = pthread_create(&t1, NULL, foo, NULL);	printf("main:%d\n", ret);
	/* OK, 0 */
	ret = pthread_create(&t2, NULL, foo2, NULL);	printf("main:%d\n", ret);

	sleep(1);

	/* 0 */
	ret = pthread_mutex_unlock(&m1);	printf("main:%d\n", ret);

	pthread_join(t1, NULL);
	pthread_join(t2, NULL);

	return 0;
}
