#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>

pthread_t t1, t2;

void* foo(void* data)
{
	int ret;
	/* EDEADLK */
        printf("foo1 joining...\n");
	ret = pthread_join(t1, NULL); printf("foo: %d\n", ret);
	sleep(2);
}

void* foo2(void* data)
{
	int ret;
	/* 0 */
	printf("foo2 joining...\n");
	ret = pthread_join(t1, NULL); printf("foo2: %d\n", ret);
	sleep(1);
}

int main(void)
{
  int ret;
  pthread_create(&t1, NULL, foo, NULL);
  pthread_create(&t2, NULL, foo2, NULL);
  sleep(1);
  /* EINVAL */
  printf("main joining...\n");
  ret = pthread_join(t1, NULL); printf("main: %d\n", ret);
  sleep(1);

  /* 0 */
  ret = pthread_join(t2, NULL); printf("main: %d\n", ret);
  /* 3 */
  printf("main joining...\n");
  ret = pthread_join(t1, NULL); printf("main: %d\n", ret);

  return 0;
}
