/** sleep.c
 *
 * This thread demonstrates how the sleep() function works in GMC in model checking mode.
 * It will not sleep for 10 seconds but it will be set as backtracking spot (equivalent of
 * an unsafe instruction).
 */

#include <unistd.h>
#include <pthread.h>
#include <stdio.h>

void* thread1(void* data)
{
	printf("thread1\n");
}

int main()
{
	pthread_t t1;
	pthread_create(&t1, NULL, thread1, NULL);
	sleep(10);
	printf("main\n");
	return 0;
}
