// 
// GMC Gimple Model Checker
// Copyright (C) 2009-2011 GMC team
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as 
// published by the Free Software Foundation, either version 3 of 
// the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public 
// License along with this program.  
// If not, see <http://www.gnu.org/licenses/>.

#ifndef CONTENTUNDO_H
#define	CONTENTUNDO_H

#include "AreaUndo.h"

namespace mmodule { namespace detail {
class AreaEntry;
class ContentEntry;

/**
 * Abstract predecesor for undoable and redoable changes to @c Content of
 * a memory area.
 */
class ContentUndo : public AreaUndo {
public:
    ContentUndo(AreaEntry* area, ContentEntry* content);
protected:
    ContentEntry* m_content;
};

}}

#endif	/* CONTENTUNDO_H */

